Declare GDIPlus&

DEF MoveMemory(3) ! "Kernel32","RtlMoveMemory"
DEF IIDFromString(2) ! "Ole32","IIDFromString"

Proc S2WS'String to WideString
Parameters S$
Declare w$
w$ = Space$((Len(s$)*2)+1)
~MultiByteToWideChar(~CP_ACP, 0, ADDR(s$), -1, ADDR(w$), Len(w$)+1)
Return w$
EndProc

Proc WS2S'WideString to String
Parameters w$
Declare s$
s$ = space$(len(w$)/2)
~WideCharToMultiByte(~CP_ACP,0,ADDR(w$),-1,ADDR(s$),Len(s$),0,0)
Return Trim$(s$)
EndProc

Proc InitGDIPlus
GDIPlus& = UseDLL("GDIPLUS.DLL")
Declare gdpsi#,gdiplusToken&
STRUCT GdiplusStartupInput = ~GdiplusStartupInput
Dim gdpsi#,GdiplusStartupInput
gdpsi#.GdiplusVersion& = 1
gdpsi#.DebugEventCallback& = 0
gdpsi#.SuppressBackgroundThread& = 0
gdpsi#.SuppressExternalCodecs& = 0
~GdiplusStartup(ADDR(gdiplusToken&),gdpsi#,0)
Dispose gdpsi#
Return gdiplusToken&
EndProc

Proc ExitGDIPlus
Parameters gdiplusToken&
~GdiplusShutdown(gdiplusToken&)
FreeDLL GDIPlus&
Endproc

Proc GetEncoderCLSID
Parameters format$,encoderCLSID&
Declare result&,encoderInfo#,num&,encodersSize&,j&,k&,num&,mimeW&,buffer$
Result& = 0
~GdipGetImageEncodersSize(ADDR(num&),ADDR(encodersSize&))
If encodersSize& = 0
   return 0
else
Dim encoderInfo#,encodersSize&
~GdipGetImageEncoders(num&,encodersSize&,encoderInfo#)
WhileNot j& = num&
  buffer$ = Space$(80)
  mimeW& = Long(encoderInfo#,k& + 48)
  ~WideCharToMultiByte(~CP_ACP,0,MimeW&,-1,ADDR(Buffer$),80,0,0)
  If Trim$(Buffer$) = format$
    MoveMemory(encoderCLSID&,encoderInfo#+k&,16)
    Result& = 1
  Endif
  k& = k& + 76
  Inc j&
EndWhile
Dispose encoderInfo#
Endif
return result&
EndProc

Proc SaveAsJPG
Parameters Bitmap&,Image$,Quality&
Declare encoderCLSID#,result&,newFile$
result& = 0
Dim encoderCLSID#,16
Declare encoderParameters#
Declare wTemp$,encoder#
wTemp$ = S2WS(~EncoderQuality)
Dim encoder#,16
IIDFromString(ADDR(wTemp$),encoder#)
Dim encoderParameters#,32
Long encoderParameters#,0 = 1
MoveMemory(encoderParameters#+4,encoder#,16)
Long encoderParameters#,20 = 1
Long encoderParameters#,24 = ~EncoderParameterValueTypeLong
Long encoderParameters#,28 = ADDR(Quality&)
If GetEncoderCLSID("image/jpeg",encoderCLSID#)
newFile$ = S2WS(Image$)
~DeleteFile(ADDR(Image$))
~GdipSaveImageToFile(Bitmap&,ADDR(newFile$),encoderCLSID#,encoderParameters#)
Dispose encoder#
Dispose encoderParameters#
Dispose encoderCLSID#
result& = 1
Endif
Return result&
EndProc

Proc SaveAsGIF
Parameters Bitmap&,Image$
Declare encoderCLSID#,result&,newFile$
result& = 0
Dim encoderCLSID#,16
If GetEncoderCLSID("image/gif",encoderCLSID#)
newFile$ = S2WS(Image$)
~DeleteFile(ADDR(Image$))
~GdipSaveImageToFile(Bitmap&,ADDR(newFile$),encoderCLSID#,0)
Dispose encoderCLSID#
result& = 1
Endif
Return result&
EndProc

Proc SaveAsBMP
Parameters Bitmap&,Image$
Declare encoderCLSID#,result&,newFile$
result& = 0
Dim encoderCLSID#,16
newFile$ = S2WS(Image$)
If GetEncoderCLSID("image/bmp",encoderCLSID#)
~DeleteFile(ADDR(Image$))
~GdipSaveImageToFile(Bitmap&,ADDR(newFile$),encoderCLSID#,0)
Dispose encoderCLSID#
result& = 1
Endif
Return result&
EndProc

Proc SaveAsPNG
Parameters Bitmap&,Image$
Declare encoderCLSID#,result&,newFile$
result& = 0
Dim encoderCLSID#,16
If GetEncoderCLSID("image/png",encoderCLSID#)
newFile$ = S2WS(Image$)
~DeleteFile(ADDR(Image$))
~GdipSaveImageToFile(Bitmap&,ADDR(newFile$),encoderCLSID#,0)
Dispose encoderCLSID#
result& = 1
Endif
Return result&
EndProc

Proc SaveAsTIF
Parameters Bitmap&,Image$
declare encoderCLSID#,result&,newFile$
result& = 0
Dim encoderCLSID#,16
If GetEncoderCLSID("image/tiff",encoderCLSID#)
newFile$ = S2WS(Image$)
~DeleteFile(ADDR(Image$))
~GdipSaveImageToFile(Bitmap&,ADDR(newFile$),encoderCLSID#,0)
Dispose encoderCLSID#
result& = 1
Endif
Return result&
EndProc

Proc gdipLoadImage
Parameters Image$
Declare result&,FileW$,Bitmap&
result& = 0
FileW$ = S2WS(Image$)
~GdipCreateBitmapFromFile(ADDR(FileW$),ADDR(Bitmap&))
if Bitmap&
result& = Bitmap&
Endif
return result&
EndProc

Proc MakeColor
Parameters a&,r&,g&,b&
Declare Result&
Result& = b& | g& << 8 | r& << 16 | a& << 24
Return Result&
EndProc


Proc Single
'###################################
'nach einer Idee von Sebastian Knig
'###################################
Parameters double!
 Declare HIDWORD&,LODWORD&
 Declare sign&,exp&,mant&
 Declare Single&
 MoveMemory(Addr(LODWORD&),Addr(double!),4)
 MoveMemory(Addr(HIDWORD&),Addr(double!)+4,4)
 if HIDWORD& < 0
  sign& = 1
  HIDWORD& = SetBit(HIDWORD&,31,0)
 else
  sign& = 0
 endif
 exp& = HIDWORD& >> 20 - 1023 + 127
 mant& = ((HIDWORD& << 12) >> 12) | (LODWORD& >> 29)
 Single& = (exp& << 23) | mant& << 3
 if (sign&)
  Single& = SetBit(Single&,31,1)
 endif
 if @equ(double!,0.00000000)
  Single& = $00000000
 endif
 Return Single&
Endproc
